
#define NPALMMESHES        4

#define NKLARTPARAMS      21

#define GLWIN_ID_VIEW      1
#define BTN_ID_EXIT        2
#define SW_ID_MESH0        3
#define SW_ID_MESH1        4
#define SW_ID_MESH2        5
#define SW_ID_MESH3        6
#define SW_ID_MESH4        7
#define SL_ID_ARTP0        8

#define KNOTWD_ID         29 /* SL_ID_ARTP0 + NKLARTPARAMS */
#define BTN_ID_PLAY       30
#define BTN_ID_LEFT       31
#define BTN_ID_SET        32
#define BTN_ID_RIGHT      33
#define SW_ID_EDIT_KNOTS  34
#define SW_ID_KNW_PANZOOM 35
#define SW_ID_ANIMATE_KL  36
#define SW_ID_ANIMATE_MM  37
#define SW_ID_ANIMATE_VP  38

#define MAXKEYFRAMES     100

#define WMSG_ANIMATION_ON  1
#define WMSG_ANIMATION_OFF 2


typedef struct {
    char         sw[NPALMMESHES+1];
    float        artp[NKLARTPARAMS];
    char         animate_mm, animate_vp, animate_kl;
    KnotsWidgetf kw;
    char         animation;
  } AppWidgets;

AppWidgets *InitMyWorld ( int argc, char *argv[], int width, int height );
void ResizeMyWorld ( int width, int height );
void RedrawMyWorld ( void );
void DeleteMyWorld ( void );
void RotateViewer ( double delta_xi, double delta_eta );

char ProcessSwitchCommand ( int wdg_id );
char ProcessSlidebarCommand ( int wdg_id );
char ProcessButtonCommand ( int wdg_id );
char ProcessCharCommand ( char charcode );
char ProcessKnotWidgetCommand ( int wdg_id, int msg, int x );

char MoveOn ( void );

char ProcessWorldRequest ( int msg, void *data, void *reply );
