
#define SHADOW_MAP_SIZE 1024

#define MAX_NLIGHTS   8

typedef struct LSPar {
          GLfloat position[4];
          GLfloat ambient[3];
          GLfloat direct[3];
          GLfloat attenuation[3];
          GLuint  shadow_fbo, shadow_txt;
          GLfloat shadow_view[16], shadow_proj[16];
        } LSPar;

typedef struct LightBl {
          GLuint lsbuf;
          GLuint nls, mask, shmask;
          LSPar  ls[MAX_NLIGHTS];
        } LightBl;


void GetAccessToLightMatUniformBlocks ( GLuint program_id );
void AttachUniformLightMatBlockToBP ( GLuint program_id );
GLuint NewUniformLightBlock ( void );
GLuint NewUniformMatBlock ( void );

void SetLightAmbient ( LightBl *light, int l, GLfloat amb[3] );
void SetLightDirect ( LightBl *light, int l, GLfloat dir[3] );
void SetLightPosition ( LightBl *light, int l, GLfloat pos[4] );
void SetLightAttenuation ( LightBl *light, int l, GLfloat at3[3] );
void SetLightOnOff ( LightBl *light, int l, char on );

void ConstructShadowTxtFBO ( LightBl *light, int l );
void UpdateShadowMatrix ( LightBl *light, int l );
void SetupShadowTxtTransformations ( LightBl *light, int l, float sc[3], float R );
void BindShadowTxtFBO ( GLuint trbuf, LightBl *light, int l );
void DeleteShadowFBO ( LightBl *light );
void SetShadowsOnOff ( LightBl *light, char on );

void SetupMaterial ( GLuint matbuf, const GLfloat ambr[3], const GLfloat diffr[3],
                     const GLfloat specr[3],
                     GLfloat shn, GLfloat wa, GLfloat we );
void ChooseMaterial ( GLuint matbuf );

