
#define MAX_NLIGHTS   8

typedef struct LSPar {
          GLfloat position[4];
          GLfloat ambient[3];
          GLfloat direct[3];
          GLfloat attenuation[3];
        } LSPar;

typedef struct LightBl {
          GLuint lsbuf;
          GLuint nls, mask;
          LSPar  ls[MAX_NLIGHTS];
        } LightBl;


void GetAccessToLightMatUniformBlocks ( GLuint program_id );
void AttachUniformLightBlockToBP ( GLuint program_id );
GLuint NewUniformLightBlock ( void );
GLuint NewUniformMatBlock ( void );

void SetLightAmbient ( LightBl *light, int l, GLfloat amb[3] );
void SetLightDirect ( LightBl *light, int l, GLfloat dir[3] );
void SetLightPosition ( LightBl *light, int l, GLfloat pos[4] );
void SetLightAttenuation ( LightBl *light, int l, GLfloat at3[3] );
void SetLightOnOff ( LightBl *light, int l, char on );

void SetupMaterial ( GLuint matbuf, const GLfloat ambr[3], const GLfloat diffr[3],
                     const GLfloat specr[3],
                     GLfloat shn, GLfloat wa, GLfloat we );
void ChooseMaterial ( GLuint matbuf );

