
#define STATE_NOTHING 0
#define STATE_TURNING 1

#define PROJ_LINEAR          0
#define PROJ_POINT_PANORAMA  1
#define PROJ_LINEAR_PANORAMA 2
#define PROJ_SPHERICAL       3

#define WIDTH  752
#define HEIGHT 423
/*
#define RR      0.8
#define VDIST  10.0
#define NEAR    2.5
#define FAR    15.0
*/
/*
#define RR      1.1
#define VDIST   5.0
#define NEAR    1.25
#define FAR    10.0
*/

#define RR      0.51
#define VDIST   1.25
#define DDIST   2.0
#define NEAR    0.5
#define FAR     7.5

/*
#define RR      0.5
#define VDIST   1.0
#define DDIST   1.75
#define NEAR    0.25
#define FAR     7.5
*/
typedef struct TransBl {
          GLuint  trbuf;
          GLfloat mm[16], mmti[16], vm[16], pm[16];
          GLfloat eyepos[4];
        } TransBl;

extern GLuint shader_id[6];
extern GLuint program_id[2];
extern GLuint trbi, trbbp,       /* dostep do przeksztalcen */
              nltbi, nltbuf, nltbbp,
              lsbi, lsbbp;       /* dostep do swiatel */
extern GLint  trbsize, trbofs[5],
              nltbsize, nltbofs[2],
              lsbsize, lsbofs[11];
              
extern float   model_rot_axis[3];
extern double  model_rot_angle0, model_rot_angle;
extern TransBl trans;
extern LightBl light;

/*extern GLFWwindow  *mywindow;*/
extern int         win_width, win_height;
extern double      last_xi, last_eta;
extern float       left, right, bottom, top, near, far;
extern int         app_state;
extern float       viewer_rvec[3];
extern float       viewer_rangle;
extern const float viewer_pos0[4];
extern GLint       BezNormals;
extern GLint       TessLevel;
extern char        animate;
extern char        proj_type;

void SetupProjection ( int width, int height, GLint type );
void SetupModelMatrix ( float axis[3], float angle, GLfloat mat[16] );
void InitViewMatrix ( void );
void RotateViewer ( double deltaxi, double deltaeta );

void InitLights ( void );

void DrawMyScene ( void );

void LoadMyShaders ( void );
void InitMyObject ( void );
void DeleteMyObject ( void );

/*
void myGLFWErrorHandler ( int error, const char *description );
void ReshapeFunc ( GLFWwindow *win, int width, int height );
void DisplayFunc ( GLFWwindow *win );
void MouseFunc ( GLFWwindow *win, int button, int action, int mods );
void MotionFunc ( GLFWwindow *win, double x, double y );
void CharFunc ( GLFWwindow *win, unsigned int charcode );
*/
void IdleFunc ( void );

void Initialise ( int argc, char **argv );
void Cleanup ( void );
void SetIdleFunc ( void(*IdleFunc)(void) );
void MessageLoop ( void );
