
#define STATE_NOTHING 0
#define STATE_TURNING 1

#define ANGULAR_VELOCITY 0.78539816  /* PI/4 */

#define MIN_LEVEL   0
#define MAX_LEVEL_P 12
#define MAX_LEVEL_M 5

extern GLuint  program_id[4];
extern GLint   levelloc[4], ColourSourceLoc[4];
extern GLint   LightingModelLoc[4], lighting_model;
extern float   model_rot_axis[3];
extern double  model_rot_angle;
extern const float viewer_pos0[4];
extern TransBl trans;
extern LightBl light;
extern GLuint  lsbuf;

extern int   WindowHandle;
extern int   win_width, win_height;
extern int   last_xi, last_eta;
extern float left, right, bottom, top, near, far;
extern int   app_state;
extern float viewer_rvec[3];
extern double viewer_rangle;
extern int   ono, level[2];
extern char  animate, clip;

void SetupModelMatrix ( float axis[3], float angle );
void InitViewMatrix ( void );
void RotateViewer ( int deltaxi, int deltaeta );
void DrawTheObject ( int ono );
void DrawClippedSponge ( void );
void InitLights ( void );

void LoadMyShaders ( void );
void InitMyObject ( void );
void Cleanup ( void );

void ToggleAnimation ( void );
void ToggleLight ( void );

void ReshapeFunc ( int width, int height );
void DisplayFunc ( void );
void KeyboardFunc ( unsigned char key, int x, int y );
void MouseFunc ( int button, int state, int x, int y );
void MotionFunc ( int x, int y );
void TimerFunc ( int value );
void IdleFunc ( void );

void Initialise ( int argc, char *argv[] );

