#include <stdlib.h>
#include <stdio.h>
#include "../utilities/openglheader.h" /* najpierw ten */
#include <GL/freeglut.h>  /* potem ten */

#include "../utilities/utilities.h"
#include "myheader.h"

int WindowHandle;

void ReshapeFunc ( int width, int height )
{
  ResizeMyWorld ( width, height );
} /*ReshapeFunc*/

void DisplayFunc ( void )
{
  RedrawMyWorld ();
  glutSwapBuffers ();
} /*DisplayFunc*/

void Cleanup ( void )
{
  DeleteMyWorld ();
  glutDestroyWindow ( WindowHandle );
} /*Cleanup*/

void KeyboardFunc ( unsigned char charcode, int x, int y )
{
  switch ( charcode ) {
case 0x1B:  /* <Esc> */
    Cleanup ();
    glutLeaveMainLoop ();
    break;
default:
    break;
  }
} /*KeyboardFunc*/

void SpecialKeyFunc ( int key, int x, int y )
{
} /*SpecialKeyFunc*/

void MouseFunc ( int button, int state, int x, int y )
{
} /*MouseFunc*/

void MotionFunc ( int x, int y )
{
} /*MotionFunc*/

void JoystickFunc ( unsigned int buttonmask, int x, int y, int z )
{
} /*JoystickFunc*/

void TimerFunc ( int value )
{
} /*TimerFunc*/

void IdleFunc ( void )
{
} /*IdleFunc*/

void Initialise ( int argc, char *argv[] )
{
  glutInit ( &argc, argv );
  glutInitContextVersion ( 2, 1 );  /* musi byc tyle */
  glutInitContextFlags ( GLUT_FORWARD_COMPATIBLE );
  glutInitContextProfile ( GLUT_CORE_PROFILE );
  glutSetOption ( GLUT_ACTION_ON_WINDOW_CLOSE,
                  GLUT_ACTION_GLUTMAINLOOP_RETURNS );
  glutInitWindowSize ( 480, 360 );
  glutInitDisplayMode ( GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA );
  WindowHandle = glutCreateWindow ( "Aplikacja FreeGLUTa" );
  if ( WindowHandle < 1 )
    ExitOnError ( "Could not create a window." );
  GetGLProcAddresses ( 4, 2 );
  glutReshapeFunc ( ReshapeFunc );
  glutDisplayFunc ( DisplayFunc );
  glutKeyboardFunc ( KeyboardFunc );
  glutSpecialFunc ( SpecialKeyFunc );
  glutMouseFunc ( MouseFunc );
  glutMotionFunc ( MotionFunc );
  /*glutJoystickFunc ( JoystickFunc, 16 );*/
  /*glutTimerFunc ( 0, TimerFunc, 0 );*/
  /*glutIdleFunc ( IdleFunc );*/
  InitMyWorld ( argc, argv, 480, 360 );
} /*Initialise*/

int main ( int argc, char *argv[] )
{
  Initialise ( argc, argv );
  glutMainLoop ();
  exit ( 0 );
} /*main*/

