
#ifndef GPUSPARSEMAT_H
#define GPUSPARSEMAT_H

typedef struct {
    int    m, n, nnz, lmax;
    GLuint buf[2];
  } GPUSparseMatrix;

void LoadGPUMultMVfShader ( void );
void DeleteGPUMultMVfProgram ( void );
void GPUMultSparseMatrixVectorf ( GLuint ybuf,
                        GPUSparseMatrix *a, GLuint dim, GLuint xbuf );

void LoadGPUSMultMVfShader ( void );
void DeleteGPUSMultMVfProgram ( void );
void GPUSMultSparseMatrixVectorf ( GLuint ybuf,
                        GPUSparseMatrix *a, GLuint dim, GLuint xbuf );

void LoadGPUMultMMfShader ( void );
void DeleteGPUMultMMfProgram ( void );
char GPUMultSparseMatricesf ( GPUSparseMatrix *c,
                              GPUSparseMatrix *a, GPUSparseMatrix *b );

void LoadGPUTransposefShader ( void );
void DeleteGPUTransposefShader ( void );
char GPUTransposeSparsef ( GPUSparseMatrix *at, GPUSparseMatrix *a,
                           char keep_a );
#endif
